package api

import "gorm.io/gorm"

const (
	keyPrincipalContextID key = iota
)

type genericResponseFields map[string]any

type key int

// ZoneRequest represents a Zone file request.
type ZoneRequest struct {
	*Zone

	User string `json:"user,omitempty" gorm:"foreignKey:username;references:User"`
}

// Zone struct represents a zonefile.
type Zone struct {
	gorm.Model
	FileName    string `json:"name"`
	RawFileName string `json:"rawname"`
	Body        string `json:"body,omitempty"`
}

type GenericResponse[T map[string]any] struct {
	Response map[string]any `json:"response,omitempty"`
}
